      Program       Model_Selection_D_km_MDP_Model
	USE           IMSL

c     Copyright: Junfeng Liu, Yale University School of Medicine, November-09-2004

      integer       nd,nc,p
	parameter     (nd=20000,nc=4,p=4)
	real          bet(nd,4),e(nd,4),z(nd,4),delta(nd),sigma(nd)
	integer       m(nc),n(nc,5),y(nc,5),ly
	real          x(nc,5,p),u,Dkm(nc,5),t(nc,5),mu(nc,5),
     &	          Dkm_MDP
      real          w1,w2,w3,yw

	m(1)=5
	m(2)=3
	m(3)=5
	m(4)=3

      open(2,file='input.txt',status='old')
      do k=1,m(1)
	   read(2,*)(x(1,k,j),j=1,p),n(1,k),y(1,k) 
	end do
      do k=1,m(2)
	   read(2,*)(x(2,k,j),j=1,p),n(2,k),y(2,k) 
	end do
      do k=1,m(3)
	   read(2,*)(x(3,k,j),j=1,p),n(3,k),y(3,k) 
	end do
      do k=1,m(4)
	   read(2,*)(x(4,k,j),j=1,p),n(4,k),y(4,k) 
	end do
      close(2)

      open(2,file='beta.txt',status='unknown')
	do i=1,nd
	   read(2,*)(bet(i,j),j=1,4)
	end do
	close(2) 

      open(2,file='delta-sigma2.txt',status='unknown')
c	do i=1,nd
c	   read(2,*)delta(i),w1
c	   delta(i)=0.0   ! sqrt(w1)
c	   sigma(i)=1.0   ! sqrt(w1)
c	end do
	close(2) 

c     open(2,file='sigma.txt',status='unknown')
c	do i=1,nd
c	   read(2,*)sigma(i)
c	end do
c	close(2) 

c	open(2,file='z.txt',status='unknown')
c	do i=1,nd
c	   read(2,*)(z(i,j),j=1,4)
c	   do j=1,nc
c	      z(i,j)=0.0
c        end do
c	end do
c	close(2) 

      open(2,file='epsilon.txt',status='unknown')
	do i=1,nd
	   read(2,*)(e(i,j),j=1,4)
	end do
	close(2) 

	do i=1,nc
	   do j=1,5                 ! m(i)
            Dkm(i,j)=0.0
	      t(i,j)=0.0
	      mu(i,j)=0.0
	   end do
      end do

c     calculate t(i,j)

      do i=1,nc
	   do j=1,m(i)
	      write(*,*)i,j
            t(i,j)=0.0 
	      do k=1,nd
               w1=0.0
	         do ly=0,n(i,j) 
		        w2=0.0
				do l=1,p
	               w2=w2+x(i,j,l)*bet(k,l)
		        end do 
	            u=delta(k)*z(k,i)+sigma(k)*e(k,i)
	            w2=w2+x(i,j,1)*u
	      	    w1=w1+ft2(n(i,j),ly,w2)
	         end do
               t(i,j)=t(i,j)+w1
		  end do
	      t(i,j)=t(i,j)/nd
	   end do
	end do

c     calculate mu(i,j)

      do i=1,nc
	   do j=1,m(i)
	      write(*,*)i,j
            mu(i,j)=0.0 
	      do k=1,nd
		     w2=0.0
		     do l=1,p
	            w2=w2+x(i,j,l)*bet(k,l)
		     end do 
	         u=delta(k)*z(k,i)+sigma(k)*e(k,i)
	         w2=w2+x(i,j,1)*u
	         mu(i,j)=mu(i,j)+n(i,j)*exp(w2-log(1.0+exp(w2)))
		  end do
	      mu(i,j)=mu(i,j)/nd
	   end do
	end do
	    
      Dkm_MDP=0.0
	do i=1,nc
	   do j=1,m(i)
	      Dkm_MDP=Dkm_MDP
     &	   +2.0*(t(i,j)-ft1(n(i,j),mu(i,j)))
     &       +2.0*(1+1)*((ft1(n(i,j),mu(i,j))
     &       +ft1(n(i,j),1.0*y(i,j)))/(1+1)
     &       -ft1(n(i,j),(mu(i,j)+y(i,j))/(1+1)))              
	   end do
      end do
	    
      open(2,file='Dkm_MDP.txt',status='unknown')
	write(2,*)Dkm_MDP
	close(2) 

      end

      real function    ft1(n,y)
	integer          n
	real             y,y2

      y2=y
      if(y.eq.0.0)y2=y+0.5
      if(y.eq.1.0*n)y2=y-0.5
      ft1= (y2/n)*log(y2/n)+((n-y2)/n)*log((n-y2)/n)   
      write(*,*)ft1
	return
	end

      real function    ft2(n,y,w)
	integer          y,n
	real             w,y2

      ft2=exp( y*w-n*log(1.0+exp(w))+facto(n,y) )
      y2=y
	if(y.eq.0)y2=y+0.5
      if(y.eq.n)y2=y-0.5
	ft2=ft2*( (y2/n)*log(y2/n)+((n-y2)/n)*log((n-y2)/n) )  
      return
	end

      real function facto(n,y)
	integer y,n

      if(y.eq.0.or.y.eq.n)then
	   facto=1.0
	else 
         c1=0.0
   	   do k=1,n
	      c1=c1+log(k*1.0)
	   end do
         c2=0.0
	   do k=1,y
	      c2=c2+log(k*1.0)
	   end do
         c3=0.0
	   do k=1,n-y
	      c3=c3+log(k*1.0)
	   end do
	   facto=c1-c2-c3
      end if
      return 
	end