      Program  Multilevel_Binomial_Regression_Gibbs_Sampler
	USE      IMSL

c     09-30-2005, Junfeng
c     logit Link, Skew random effect modeling

c     fixed effects - bet, dimension =4 
c     random effects - e(i), i=1,2,3,4 (nc), dimension =1

      integer   p,nc
	integer*4 iseed,irank,nd,nr
	parameter (p=4,nc=4,nr=10000)
	integer   m(nc),n(nc,5),y(nc,5)
	real      x(nc,5,p)
	real      u_old(nc),u_new(nc),u(nc)
	real      delta_old,delta_new
	real      sigma2_old,sigma2_new
	real      epsi_old(nc),epsi_new(nc)
	real      z_old(nc),z_new(nc)
	real      beta_old(p),beta_new(p),cov(p,p),rc(p,p),wnb(nr,p)
	real      delta,sigma2,epsi(nc),z(nc),bet(p),value_old,value_new
      real      w
	real      mu_delta,sigma_delta,alpha_sigma2,beta_sigma2,
     &	      mu_Z,sigma_Z,mu_epsi,sigma_epsi
      real      u1(nr),u2(nr),u3(nr),u4(nc*nr),u5(nc*nr),u6(nr),
     &	      u_sigma2(nr),u_delta(nr),u_z(nc*nr),u_epsi(nc*nr)
      

	common /x/     x
      common /mny/   m,n,y
      common /prior/ mu_delta,sigma_delta,alpha_sigma2,beta_sigma2,
     &	           mu_Z,sigma_Z,mu_epsi,sigma_epsi

c     The following are not used in normal case:

      alpha_sigma2=3
	beta_sigma2=100
      
	mu_delta=0.0
      sigma_delta=0.01
c      sigma_delta=0.1

	mu_z=0.0
c      sigma_z=0.01
      sigma_z=0.1

c     The epsilon is used in normal case
      
	mu_epsi=0.0
c      sigma_epsi=0.01
      sigma_epsi=0.1

	m(1)=5
	m(2)=3
	m(3)=5
	m(4)=3

	do i=1,p
  	   do j=1,p
	      cov(i,j)=0.0
	      if(i.eq.j)cov(i,j)=0.01
	   end do
	end do
      
      open(7,file='input.txt',status='old')
      do k=1,m(1)
	   read(7,*)(x(1,k,j),j=1,p),n(1,k),y(1,k) 
	end do
      do k=1,m(2)
	   read(7,*)(x(2,k,j),j=1,p),n(2,k),y(2,k) 
	end do
      do k=1,m(3)
	   read(7,*)(x(3,k,j),j=1,p),n(3,k),y(3,k) 
	end do
      do k=1,m(4)
	   read(7,*)(x(4,k,j),j=1,p),n(4,k),y(4,k) 
	end do
      close(7)

      iseed=13
      call chfac(p,cov,p,0.00001,irank,rc,p)

	delta_old=0.0
	sigma2_old=0.01
	
	do i=1,nc
	   epsi_old(i)=0.0
	   z_old(i)=0.0
	end do
	
	do j=1,p
	   beta_old(j)=0.0
	end do

      open(2,file='Delta-Sigma2.txt',status='unknown')
      open(3,file='Z.txt',status='unknown')
      open(4,file='Epsilon.txt',status='unknown')
      open(5,file='Beta.txt',status='unknown')

      nd=0
   
1     iseed=iseed+2                      !  for updating beta vector
	call rnset(iseed)
	call rnmvn(nr,p,rc,p,wnb,nr)
	
	iseed=iseed+2
      call rnset(iseed)
	call rnun(nr,u1)
	
	iseed=iseed+2
      call rnset(iseed)
	call rnun(nr,u2)

	iseed=iseed+2
      call rnset(iseed)
	call rnun(nr,u3)

	iseed=iseed+2
      call rnset(iseed)
	call rnun(nc*nr,u4)

	iseed=iseed+2
      call rnset(iseed)
	call rnun(nc*nr,u5)

	iseed=iseed+2
      call rnset(iseed)
	call rnun(nr,u6)
	
	iseed=iseed+2
      call rnset(iseed)
	call rngam(nr,alpha_sigma2,u_sigma2)
      
	do j=1,nr
	   u_sigma2(j)=u_sigma2(j)*beta_sigma2
	   u_sigma2(j)=1.0/u_sigma2(j)
	end do

	iseed=iseed+2
      call rnset(iseed)
	do i=1,nc*nr
	   u_epsi(i)=rnnof()*sigma_epsi
      end do

	do i=1,nr
    
         nd=nd+1

	   delta_old=0.0
         sigma2_old=1.0
	   do j=1,nc
	      z_old(j)=0.0
         end do

c    calculate the old log-likelihood value for beta_old
	   
         call log_likelihood(beta_old,delta_old,sigma2_old,
     &	                   z_old,epsi_old,value_old)

c    propose new beta candidate

         do j=1,p
	      beta_new(j)=beta_old(j)+wnb(i,j)
         end do

c    calculate the new log-likelihood value for beta_new

	   call log_likelihood(beta_new,delta_old,sigma2_old,z_old,
     &	                   epsi_old,value_new)

         if(log(u1(i)).le.min(0.0,value_new-value_old) )then
            do j=1,p
  	         beta_old(j)=beta_new(j)
            end do
	   end if

c        Normal Random Effect - the simplist one 
 
         delta_old=0.0
         sigma2_old=1.0
 	   do j=1,nc
	      z_old(j)=0.0
         end do

         do j=1,nc   

c    calculate the old log-likelihood value for epsi_old

	      call log_likelihood(beta_old,delta_old,sigma2_old,
     &		                  z_old,epsi_old,value_old)

c    propose new epsi candidate

            do k=1,nc
	         epsi(k)=epsi_old(k)   
	      end do

            epsi_new(j)=u_epsi(nc*(i-1)+j)
	      epsi(j)=epsi_new(j)

c    calculate the new log-likelihood value for epsilon_new

	      call log_likelihood(beta_old,delta_old,sigma2_old,
     &		                  z_old,epsi,value_new)

            w=sigma_epsi
            value_new=value_new-0.5*(epsi_old(j)/w)**2-log(sqrt(w))

            value_old=value_old-0.5*(epsi_new(j)/w)**2-log(sqrt(w))

            if(log(u5(nc*(i-1)+j)).le.min(0.0,value_new-value_old) )then
  	         epsi_old(j)=epsi_new(j)
	      end if
         end do

  	   if(mod(nd,5000).eq.0)then
            write(*,*)nd/5000
	      write(*,101)beta_old
	      write(*,101)epsi_old
	      write(*,101)delta_old,sigma2_old
	      write(*,101)z_old
	      write(2,101)delta_old,sigma2_old
	      write(3,101)z_old
	      write(4,101)epsi_old
	      write(5,101)beta_old
	   end if 

      end do

	if(nd.lt.1D08)goto 1 

      close(2)
      close(3)
      close(4)
      close(5)

101   format(5f15.6)

	end

c     subroutine for calculating log-posterior function

      subroutine   log_likelihood(bet,delta,sigma2,z,epsi,value)

      integer      p,nc
	parameter    (p=4,nc=4)
	integer      m(nc),n(nc,5),y(nc,5)
	real         x(nc,5,p)
	real         u(nc),delta,sigma2,epsi(nc),z(nc),bet(p),value
      real         w
	real         mu_delta,sigma_delta,alpha_sigma2,beta_sigma2,
     &	         mu_Z,sigma_Z,mu_epsi,sigma_epsi

	common /x/   x
      common /mny/ m,n,y
      common /prior/ mu_delta,sigma_delta,alpha_sigma2,beta_sigma2,
     &	           mu_Z,sigma_Z,mu_epsi,sigma_epsi

	value=0.0

c     likelihood function part
	
	do i=1,nc
	   u(i)=delta*z(i)+sqrt(sigma2)*epsi(i)            ! random effect for group (i)
	   do j=1,m(i)
	      w=0.0
		  do k=1,p
	         w=w+x(i,j,k)*bet(k)
		  end do 
	      w=w+u(i)
	      value=value+y(i,j)*w-n(i,j)*log(1.0+exp(w))   
	   end do
	end do

      do i=1,4
         value=value-0.5*((epsi(i)-mu_epsi)/sigma_epsi)
     &	              *((epsi(i)-mu_epsi)/sigma_epsi)
      end do

	return
	end