      Program       Model_Selection_DIC_Skew_normal_Model
	USE           IMSL

c     Copyright: Junfeng Liu, Yale University School of Medicine, November-09-2004

      integer       nd,nc,p
	parameter     (nd=20000,nc=4,p=4)
	real          bet(nd,4),e(nd,4),z(nd,4),delta(nd),sigma(nd)
	integer       m(nc),n(nc,5),y(nc,5),ly
	real          x(nc,5,p),u,DIC(nc,5),DIC1(nc,5),DIC2(nc,5),
     &	          DIC3(nc,5),DIC_skew_normal
      real          w1,w2,w_beta(p),w_e(nc),w_z(nc),w_delta,w_sigma

	m(1)=5
	m(2)=3
	m(3)=5
	m(4)=3

      open(2,file='input.txt',status='old')
      do k=1,m(1)
	   read(2,*)(x(1,k,j),j=1,p),n(1,k),y(1,k) 
	end do
      do k=1,m(2)
	   read(2,*)(x(2,k,j),j=1,p),n(2,k),y(2,k) 
	end do
      do k=1,m(3)
	   read(2,*)(x(3,k,j),j=1,p),n(3,k),y(3,k) 
	end do
      do k=1,m(4)
	   read(2,*)(x(4,k,j),j=1,p),n(4,k),y(4,k) 
	end do
      close(2)

      open(2,file='beta.txt',status='unknown')
	do i=1,nd
	   read(2,*)(bet(i,j),j=1,4)
	end do
	close(2) 

      open(2,file='delta-sigma2.txt',status='unknown')
	do i=1,nd
	   read(2,*)delta(i),w1
	   sigma(i)=sqrt(w1)
	end do
	close(2) 

c      open(2,file='sigma.txt',status='unknown')
c	do i=1,nd
c	   read(2,*)sigma(i)
c	   sigma(i)=1.0
c	end do
c	close(2) 

	open(2,file='z.txt',status='unknown')
	do i=1,nd
	   read(2,*)(z(i,j),j=1,4)
	end do
	close(2) 

      open(2,file='epsilon.txt',status='unknown')
	do i=1,nd
	   read(2,*)(e(i,j),j=1,4)
	end do
	close(2) 

	do i=1,nc
	   do j=1,5                 ! m(i)
            DIC1(i,j)=0.0
            DIC2(i,j)=0.0
            DIC3(i,j)=0.0
	   end do
      end do

c     calculate DIC1(i,j) ~ 2*log f(y_i|theta(y_i))

      do i=1,nc
	   do j=1,m(i)
            DIC1(i,j)=2.0*ft2(n(i,j),y(i,j))+2.0*facto(n(i,j),y(i,j))
 	   end do
	end do

c     calculate DIC2(i,j) ~ 2*log f(y_i|theta mean)

	do j=1,p
	   w_beta(j)=0.0
	   do k=1,nd
            w_beta(j)=w_beta(j)+bet(k,j)
	   end do
	   w_beta(j)=w_beta(j)/nd
	end do

      do j=1,nc
         w_z(j)=0.0
         w_e(j)=0.0
	   do k=1,nd
            w_z(j)=w_z(j)+z(k,j)
            w_e(j)=w_e(j)+e(k,j)
	   end do
	   w_z(j)=w_z(j)/nd
	   w_e(j)=w_e(j)/nd
	end do

      w_delta=0.0
      w_sigma=0.0
	do k=1,nd
         w_delta=w_delta+delta(k)
         w_sigma=w_sigma+sigma(k)
	end do
	w_delta=w_delta/nd
	w_sigma=w_sigma/nd

      do i=1,nc
	   do j=1,m(i)
		  w2=0.0
		  do l=1,p
	         w2=w2+x(i,j,l)*w_beta(l)
		  end do 
	      u=w_delta*w_z(i)+w_sigma*w_e(i)
	      w2=w2+x(i,j,1)*u
            DIC2(i,j)=2.0*(y(i,j)*w2-n(i,j)*log(1.0+exp(w2)))
     &		       +2.0*facto(n(i,j),y(i,j))
 	   end do
	end do

c     calculate DIC3(i,j) ~ -4*E {log f(y_i|theta) }

      do i=1,nc
	   do j=1,m(i)
            DIC3(i,j)=0.0
		  do k=1,nd
		     w2=0.0
		     do l=1,p
	            w2=w2+x(i,j,l)*bet(k,l)
		     end do 
	         u=delta(k)*z(k,i)+sigma(k)*e(k,i)
	         w2=w2+x(i,j,1)*u
               DIC3(i,j)=DIC3(i,j)+4.0*(y(i,j)*w2-n(i,j)
     &			 *log(1.0+exp(w2)))+4.0*facto(n(i,j),y(i,j))
 	      end do
            DIC3(i,j)=DIC3(i,j)/nd
	   end do
	end do
	    
      DIC_skew_normal=0.0
	do i=1,nc
	   do j=1,m(i)
	      DIC_skew_normal=DIC_skew_normal
     &		  +DIC1(i,j)++DIC2(i,j)-DIC3(i,j)
	   end do
      end do
	    
      open(2,file='DIC_skew_normal.txt',status='unknown')
	write(2,*)DIC_skew_normal
	close(2) 

      end

      real function    ft2(n,y)
	integer          y,n
	real             y2

      y2=y
      if(y.eq.0)y2=y+0.5
      if(y.eq.n)y2=y-0.5
      ft2=y2*log(y2/(n-y2))+n*log((n-y2)/n)
      return
	end

      real function facto(n,y)
	integer y,n

      if(y.eq.0.or.y.eq.n)then
	   facto=1.0
	else 
         c1=0.0
   	   do k=1,n
	      c1=c1+log(k*1.0)
	   end do
         c2=0.0
	   do k=1,y
	      c2=c2+log(k*1.0)
	   end do
         c3=0.0
	   do k=1,n-y
	      c3=c3+log(k*1.0)
	   end do
	   facto=c1-c2-c3
      end if
      return 
	end
