      Program  Multilevel_Binomial_Regression_Gibbs_Sampler
	USE      IMSL

c     05-06-2007, Junfeng Liu
c     logit Link, Skew random effects modeling

      integer   n,k,p                            !  n - number of groups, k - group size, p - covariate size
	parameter (n=4,k=4,p=2)
	real      sigma1,sigma2
      real      alpha,bet,x(n,k,p),b(n)
	integer   m(n,k),iy(n,k),iyy
	integer*4 iseed
	real      epsi(n),Z(n)
	real      eta,prob,ran_mean,w1,w2,w3
	real      u(10000)

c     alpha+b(i)+x(i,j)*beta                     !  MULTILEVEL MODEL

      alpha=-5.0
c      bet=2.0
      bet=2.0     !   (4-10)

	sigma1=0.1  !   standard error for epsilon part 

	sigma2=0.1  !   Data 1 = skewed random effects, 'c' in Dey and Liu (2006)
c	sigma2=0.0  !   Data 2 = normal random effects

c     calculate random effects mean for displacement 

      w1=sigma2*(1.0)/sigma1
	w2=w1/sqrt(1.0+w1*w1)
	w3=sqrt(sigma2*sigma2+sigma1*sigma1)
      ran_mean=(w3) * sqrt(2.0/3.1415926)*w2
      
	do i=1,n
	   do j=1,k
            m(i,j)=100
            iy(i,j)=0
	   end do
	end do

      iseed=17
	iseed=iseed+2
      call rnset(iseed)
	do i=1,n
	   epsi(i)=rnnof()*sigma1             
	   Z(i)=abs(rnnof())*sigma2           
         b(i)=Z(i)+epsi(i)-ran_mean
c         write(*,*)epsi(i),Z(i),b(i),ran_mean
      end do

      open(2,file='Simu-Data-Skew.txt',status='unknown')

	do i=1,n
	   do j=1,k
            m(i,j)=100
            iy(i,j)=0
	      x(i,j,1)=1.0                           !   design the covariate - Intercepts
	      x(i,j,2)=1.0*j                         !   design the covariate - Ages
            eta=x(i,j,1)*alpha+x(i,j,2)*bet+b(i)   !   linear prediction equation by random effects and design matrix
            prob=exp(eta)/(1.0+exp(eta))
            write(*,*)i,j,(x(i,j,kk),kk=1,p),prob
	      iseed=iseed+2

c     simulate iyy out of m 

            call simu_bino(m(i,j),iyy,prob,iseed)
	      iy(i,j)=iyy
	      write(2,100)i,j,(x(i,j,kk),kk=1,p),m(i,j),iy(i,j),prob
	   end do
	end do
	write(2,'(4f10.5)')alpha,bet,sigma1,sigma2
	close(2)
100   format(1x,2i6,2f12.6,2i8,f12.6)
      end

      subroutine  simu_bino(n,iy,p,iseed)
	real        p
	integer     n,iy
	integer*4   iseed
      real        u(100)

      call rnset(iseed)
	call rnun(100,u)
      iy=0
	do i=1,n
         if(u(i).le.p)then
	      iy=iy+1
	   end if
	end do
	return
	end